use crate::{executor::{MemoryData, MemoryRustFunction}, parser::ASTPart};

fn to_printed(from: &ASTPart) -> String {
    match from {
        ASTPart::String(s) => s.value.clone(),
        ASTPart::Number(n) => n.value.to_string(),
        ASTPart::Boolean(b) => b.value.to_string(),
        ASTPart::Null(_) => String::from("null"),
        _ => String::new()
    }
}

fn ugass(args: Vec<ASTPart>) -> ASTPart {
    let mut out = String::new();
    for arg in &args {
        out.push_str(&to_printed(arg));
        out.push_str("  ");
    }
    println!("{}", out);
    return ASTPart::NOOP;
}

pub fn generate() -> Vec<MemoryData> {
    let mut out: Vec<MemoryData> = vec![];
    out.push(MemoryData::RustFunction(MemoryRustFunction { key: String::from("ugass"), func: ugass }));
    return out;
}